<?php
/*
Plugin Name: Spoiler Button
Description: Adds "[spoiler]Spoiler Text[/spoiler]" Tags
Version: 1.4
Author: ePirat
Author URI: http://www.epirat.de/
*/

# get correct id for plugin
$thisfile=basename(__FILE__, ".php");

# register plugin
register_plugin(
	$thisfile, 
	'Spoiler Button', 	
	'1.4', 		
	'ePirat',
	'http://www.epirat.de/', 
	'Adds [spoiler][/spoiler] (BBCode Style)',
	'plugin',
	'spoiler_button_display'  
);

add_action('theme-header','code');
add_filter('content','spoiler_button_display');

# functions
function code(){
	global $content;
	if (preg_match('/\[spoiler(?:=([^]]+))?\](.*?)\[\/spoiler\]/s', $content)){
		?>
		<!-- JavaScripts -->
        <script>
            window.onload = function () {
                var spoilers = document.getElementsByClassName("spoiler");
                for (var i = spoilers.length - 1; i >= 0; i--) {
                    (function () {
                        var spoiler = spoilers[i];
                        spoiler.style.display = "none";
                        var name = spoiler.getElementsByClassName("Spoilerbuttonname");
                        switch (name.length) {
							case 0:
    							name = "Show Spoiler";
    							nameh = "Hide Spoiler";
    							break;
    						case 1:
    							name = name[0].innerText;
    							nameh = name;
    							break;
    						case 2:
    							var nameh = name[1].innerText;
    							name = name[0].innerText;
    							break;
						}
                        var button = document.createElement("button");
                        button.innerText = name;
                        spoiler.parentNode.insertBefore(button, spoiler);
                        button.addEventListener("click", function () {
                            if (spoiler.style.display !== "none") {
                                spoiler.style.display = "none";
                                button.innerText = name;
                            } else {
                                spoiler.style.display = "block";
                                spoiler.style.backgroundColor = "transparent";
                                button.innerText = nameh;
                            }
                        }, false);
                    }());
                }
            };
        </script>
		<style type="text/css">
		<!--
		div.spoiler:hover { background-color: transparent; }
		div.spoiler { background-color: #333; color: #333; }
		-->
		</style>
		<?php
	}
}

function spoiler_button_display($content)
{
		#This regex is from iszak (freenode #regex channel)
		$content = preg_replace_callback("/\[spoiler(?:=(.*?))?\](.*?)\[\/spoiler\]/s", "replika", $content);
		return $content;
}
function replika($cont) {
	$string = "<div class=\"spoiler\">";
	if (!empty($cont[1])){
		$split = explode("|||", $cont[1], 2);
		foreach ($split as $splitted){
			$string .= "<p class=\"Spoilerbuttonname\" style=\"display: none;\">".$splitted."</p>";
		}
	}
	$string .= "<p class=\"spoilertextcont\">".$cont[2]."</p></div>";
	return $string;
}
?>